System.usbDiskModeActivate()

-- ==============================
--      LOAD IMAGES & SOUNDS
-- ==============================

-- MENU
startImg = Image.load("images/menu/start.png")
selectImg = Image.load("images/menu/select.png")
hooksImg = Image.load("images/menu/hooks.png")
hooks2Img = Image.load("images/menu/hooks2.png")

-- OBJECTS
jump1 = Image.load("images/levels/jump1.png")

-- BOARDER ROTATION
manRot0 = Image.load("images/boarder/rotation/boarder_rot0.png")
manRot1 = Image.load("images/boarder/rotation/boarder_rot1.png")
manRot2 = Image.load("images/boarder/rotation/boarder_rot2.png")
manRot3 = Image.load("images/boarder/rotation/boarder_rot3.png")
manRot4 = Image.load("images/boarder/rotation/boarder_rot4.png")
manRot5 = Image.load("images/boarder/rotation/boarder_rot5.png")
manRot6 = Image.load("images/boarder/rotation/boarder_rot6.png")
manRot7 = Image.load("images/boarder/rotation/boarder_rot7.png")
manRot8 = Image.load("images/boarder/rotation/boarder_rot8.png")
manRot9 = Image.load("images/boarder/rotation/boarder_rot9.png")
manRot10 = Image.load("images/boarder/rotation/boarder_rot10.png")
manRot11 = Image.load("images/boarder/rotation/boarder_rot11.png")
manRot12 = Image.load("images/boarder/rotation/boarder_rot12.png")
manRot13 = Image.load("images/boarder/rotation/boarder_rot13.png")
manRot14 = Image.load("images/boarder/rotation/boarder_rot14.png")
manRot15 = Image.load("images/boarder/rotation/boarder_rot15.png")
manRot16 = Image.load("images/boarder/rotation/boarder_rot16.png")
manRot17 = Image.load("images/boarder/rotation/boarder_rot17.png")
manRot18 = Image.load("images/boarder/rotation/boarder_rot18.png")
manRot19 = Image.load("images/boarder/rotation/boarder_rot19.png")
manRot20 = Image.load("images/boarder/rotation/boarder_rot20.png")
manRot21 = Image.load("images/boarder/rotation/boarder_rot21.png")
manRot22 = Image.load("images/boarder/rotation/boarder_rot22.png")
manRot23 = Image.load("images/boarder/rotation/boarder_rot23.png")

-- ECRAN
white = Color.new(255, 255, 255)
blue = Color.new(0, 153, 255)

ecran = Image.createEmpty(480, 272)
ecran:clear(white)

-- ANIMATION LISTS
manRotList = {manRot0, manRot1, manRot2, manRot3, manRot4, manRot5, manRot6, manRot7, manRot8, manRot9, manRot10, manRot11, manRot12,manRot13, manRot14, manRot15, manRot16, manRot17, manRot18, manRot19, manRot20, manRot21, manRot22, manRot23}
manFrame = 7

-- SOUNDS
--SoundSystem.SFXVolume(128)
--sonAccept = Sound.load("sounds/accept.mp3")
--sonSwitch = Sound.load("sounds/switch.mp3")
--sonMenuInn = Sound.load("sounds/menu_inn.mp3")
--sonMenuOut = Sound.load("sounds/menu_out.mp3")

-- ==============================
--         MENU VARIABLES
-- ==============================

page = 1
introX = 480
hooksX = 117
timerHooks = 0
hooks = hooksImg
keyDown = false

-- ==============================
--         GAME VARIABLES
-- ==============================

pad = Controls.read()
math.randomseed(os.time())

analog_X = 0
analog_Y = 0

manX = 60
manY = 103

speed = 0
maxSpeed = 5

turnPow = 0
movePow = 0
compteur = 0

jumpCharge = 0
jumpPow = 0

jump = false

levelX = 400
levelY = 100

-- ==============================
--           MENU PAGE
-- ==============================

while true do

  pad = Controls.read()
  analog_Y = pad:analogY()
  analog_X = pad:analogX()
  
  if (pad:select()) then
    screen:clear()
    break
  end

  -- STARTING PAGE
  if (page == 1) then
    screen:blit(0, 0, startImg)
    if (pad:start()) then
      --sonAccept:play()
      screen:clear()
      page = 2
    end    
  end  

  if (page == 2) then
    introX = introX - 10
    introX2 = introX - 480
    screen:blit(introX2, 0, startImg)
    screen:blit(introX, 0, selectImg)
    if (introX <= 0) then
      screen:clear()
      introX = 480
      --sonMenuInn:play()
      page = 3
    end
  end

  -- SELECT PAGE
  if (page == 3) then
    screen:blit(0, 0, selectImg)
    if (pad:left() or analog_X < -32) then
    if (keyDown == false) then
        --sonSwitch:play()
        if (hooksX == 117) then
          hooksX = 345
        elseif (hooksX == 345) then
          hooksX = 231
        elseif (hooksX == 231) then
          hooksX = 117
        end
      end
      keyDown = true
    end
    
    if (pad:right() or analog_X > 32) then
    if (keyDown == false) then
        --sonSwitch:play()
        if (hooksX == 117) then
          hooksX = 231
        elseif (hooksX == 231) then
          hooksX = 345
        elseif (hooksX == 345) then
          hooksX = 117
        end
      end
      keyDown = true
    end 
    
    if (pad:left() == false and pad:right() == false and analog_X > -20 and analog_X < 20) then
      keyDown = false
    end
    
    timerHooks = timerHooks + 1
    if (timerHooks > 15) then
      hooks = hooksImg
    else
      hooks = hooks2Img
    end
    if (timerHooks > 30) then
      timerHooks = 0
    end

    -- BLITS
    screen:blit(hooksX, 179, hooks)
    
    if (hooksX == 117 and pad:cross()) then
    --sonAccept:play()
      screen:clear()
      page = 4
    end
  end

  -- ==============================
  --         GAME CONTROLS
  -- ==============================

  if (page == 4) then
  
    if (pad:start()) then
      --sonMenuOut:play()
      screen:clear()
      page = 3
    end

    -- JOYSTICK LEFT & RIGHT
    if (analog_Y > 32) then
      maxSpeed = 7
    else
      maxSpeed = 5
    end
    
    -- JOYSTICK UP & DOWN
    if (math.abs(analog_X) > 32) then
      turnPow = turnPow + analog_X/500
    end

    -- BUTON X (jump charge)
    --if (pad:cross()) then
      --if (jumpCharge <= 99) then
        --jumpCharge = jumpCharge + 1
      --end
    --elseif (jumpCharge > 0) then
      --jump = true
    --end

    -- ==============================
    --          MAN MOVEMENT
    -- ==============================

    -- MAN SPIN LEFT
    if (turnPow < 0) then
      if (compteur <= 1) then
        compteur = compteur + math.abs(turnPow/10)
      elseif (manFrame <= 22) then
        manFrame = manFrame + 1
        compteur = 0
      else
        manFrame = 1
        compteur = 0
      end
    end
  
    -- MAN SPIN RIGHT
    if (turnPow > 0) then
      if (compteur <= 1) then
        compteur = compteur + math.abs(turnPow/20)
      elseif (manFrame >= 2) then
        manFrame = manFrame - 1
        compteur = 0
      else
        manFrame = 23
        compteur = 0
      end
    end

    -- SPEED vs ROTATION
    -- 0 & 180 degrees
    if (manFrame == 1 or manFrame == 13) then
      speed = speed + 0.1
    end
    if (manFrame == 2 or manFrame == 14) then
      movePow = movePow - 0.05
      speed = speed + 0.05
    end
    if (manFrame == 3 or manFrame == 15) then
      movePow = movePow - 0.1
      speed = speed + 0.025
    end
    if (manFrame == 4 or manFrame == 16) then
      movePow = movePow - 0.15
      speed = speed * 0.99
    end
    if (manFrame == 5 or manFrame == 17) then
      movePow = movePow - 0.2
      speed = speed * 0.985
    end
    if (manFrame == 6 or manFrame == 18) then
      movePow = movePow - 0.25
      speed = speed * 0.978
    end
    -- 90 & 270 degrees
    if (manFrame == 7 or manFrame == 19) then
      speed = speed * 0.97
    end
    if (manFrame == 8 or manFrame == 20) then
      movePow = movePow + 0.05
      speed = speed * 0.97
    end
    if (manFrame == 9 or manFrame == 21) then
      movePow = movePow + 0.1
      speed = speed * 0.978
    end
    if (manFrame == 10 or manFrame == 22) then
      movePow = movePow + 0.15
      speed = speed * 0.99
    end
    if (manFrame == 11 or manFrame == 23) then
      movePow = movePow + 0.2
      speed = speed + 0.025
    end
    if (manFrame == 12 or manFrame == 24) then
      movePow = movePow + 0.25
      speed = speed + 0.05
    end
   
    -- SPEED LIMITS
    if (movePow > 2) then
      movePow = 2
    end
    if (movePow < -2) then
      movePow = -2
    end
  
    -- MOVEPOW LIMITS
    if (speed > maxSpeed) then
      speed = maxSpeed
    end
    if (speed < 0) then
      speed = 0
    end
  
    movePow = movePow * 0.94
    turnPow = turnPow * 0.9
  
    -- LEVEL MOVEMENT
    levelX = levelX - speed

    if (levelX <= -400) then
      levelY = math.random(20, 250)
      levelX = 500
    end
  
    -- MAN MOVEMENT
    manY = manY + movePow
    
    -- MAN LIMITS
    if (manY < -20) then
      manY = -20
    end
    
    if (manY > 230) then
      manY = 230
    end

  -- ==============================
  --          MAN JUMPS
  -- ==============================

    --if (jump == true) then
  
      --if (jumpPow <= 99) then
        --jumpPow = jumpPow + 1
      --else
        --jumpPow = 0
        --jumpCharge = 0
        --jump = false
      --end
    
      --if (jumpPow <= jumpCharge/2) then
        --manRot0 = Image:height(jumpPow)
      --end
    
    --end

  -- ==============================
  --          SCREEN BLITS
  -- ==============================

    -- BLIT ECRAN
    screen:blit(0, 0, ecran, false)

    -- BLIT JUMP1
    screen:blit(levelX, levelY, jump1)

    -- BLIT MAN
    screen:blit(manX, manY, manRotList[manFrame])
  end
  -- WAIT FOR VERTICAL SYNC
  screen.waitVblankStart()
  screen:flip()
end